#!/usr/bin/perl -w

package KartaUcetnihoPohybu;

BEGIN {
    use src::MymoneyUI;
};


use strict;


#use Encode;
use utf8;
#use open ':utf8', ':std';

use Gtk2;
init Gtk2;

use lib "./";
use lib::Dialog;
use lib::Locks;
use lib::Databaze;

my $MyUI;
my %MyMoney;
my $retcode="";
my $KartaUcetnihoPohybu;
my $Locks;

sub upravit {
    my ($self, $where, %params) = @_;
    %MyMoney=%params;
    my $dissable_ok=0;
    $Locks=0;
    if($where) {
        $Locks=new Locks(%MyMoney);
        if(!$Locks->create_lock('r_UcPohyby',$where)) {
            $dissable_ok=1;
        };
    };
    return($self->run($dissable_ok, $where,0,%params));
};

sub kopirovat {
    my ($self, $where, %params) = @_;
    %MyMoney=%params;
    $Locks=0;
    return($self->run(0, $where,1,%params));
};

sub pridat {
    my ($self, %params) = @_;
    %MyMoney=%params;
    $Locks=0;
    return($self->run(0,'',0,%params));
};

sub odstranit {
    my ($self, $where, %params) = @_;
    %MyMoney=%params;
    $Locks=new Locks(%MyMoney);
    if(!$Locks->create_lock('r_UcPohyby',$where,1)) {
        return(0);
    };
    my $Databaze=new Databaze(%MyMoney);
    if(!$Databaze->Remove("r".$MyMoney{'RokData'}->get('id')."_UcPohyby",$where)) {
        $Locks->remove_lock;
        return(0);
    };
    $Locks->remove_lock;
    return(1);
};


#sloupce v penezniho deniku


my @sloupce_penden=(
    #prijmy
    ['Příjmy za zboží','PZbo'],
    ['Příjmy za služby','PSlu'],
    ['Ostatní příjmy podléhající dani','POst'],
    ['Příjmy - srážky','P1?'],
    ['Příjmy - DPH','PDPH'],
    ['Příjmy - dotace','P2?'],
    ['Příjmy - vklad','PVkl'],
    ['Ostatní příjmy nepodléhající dani','POsN'],
    ['Převod z průběžných položek','PPrP'],
    
    #vydaje
    ['Výdaje za materiál','VMat'],
    ['Výdaje za zboží','VZbo'],
    ['Výdaje za drobný majetek','VDrM'],
    ['Výdaje za mzdy','VMzd'],
    ['Výdaje za daň z mezd','VDMz'],
    ['Výdaje za sociální pojištění','VSoP'],
    ['Výdaje za zdravotní pojištění','VZdP'],
    ['Režijní výdaje','VRez'],
    ['Výdaje - HIM','VHIM'],
    ['Výdaje - DPH','VDPH'],
    ['Výdaje - rezerva','V1?'],
    ['Výdaje - daň z příjmů','VDzP'],
    ['Výdaje - osobní','VOso'],
    ['Výdaje - dary','V2?'],
    ['Ostatní výdaje nepodléhající dani','VOsN'],
    ['Převod na průběžné položky','VPrP'],
);
    


sub run {
    my ($class, $dissable_ok, $where, $kopie, %params) = @_;
    $retcode=0;
    %MyMoney=%params;
    my $window=$class;
    $MyUI=$class;
    my $self=$class;
    $KartaUcetnihoPohybu=new Table('r_UcPohyby',%MyMoney);
    if(!$kopie) {
        $class->{'where'}=$where;
    } else {
        $class->{'where'}="";
    };
    if($dissable_ok) {
        $window->FORM->{'button_ok'}->set_sensitive(0);
    };

    if($where) {
        if(!$KartaUcetnihoPohybu->load($where,1)) {
            my $Dialog=new Dialog;
            $Dialog->show("text"=>"Záznam nelze načíst!\nZřejme byl změněn jiným uživatelem.","type"=>"error");
            if($Locks) {
                $Locks->remove_lock;
            };
            return(0);
        };
    };
    
    # vyrobime option menu sloupce penden
    foreach $_ (@sloupce_penden) {
        my @sl=@{$_};
        $window->FORM->{'sloupec_'.$sl[1]}=new_with_mnemonic Gtk2::MenuItem($sl[0]);
        $window->FORM->{'menu61'}->append($window->FORM->{'sloupec_'.$sl[1]});
        $window->FORM->{'sloupec_'.$sl[1]}->show;
    };
    
    $MyUI->on_typ_toggled;
    $KartaUcetnihoPohybu->WriteToUI($window->FORM);
    $window->set_sloupec($KartaUcetnihoPohybu->get('sloupec'));

    
    $MyUI=$window;
    $window->TOPLEVEL->set_title('Karta účetního pohybu');
    $MyMoney{'MainCfg'}->window_open("KartaUcetnihoPohybu",$self->TOPLEVEL);
    $window->TOPLEVEL->show;
    Gtk2->main;
    return($retcode);
};

sub on_button_close_clicked {
    if($Locks) {
        $Locks->remove_lock;
    };
    $MyMoney{'MainCfg'}->window_close("KartaUcetnihoPohybu",$MyUI->TOPLEVEL);
    $MyUI->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub on_KartaUcetnihoPohybu_unrealize {
    if($Locks) {
        $Locks->remove_lock;
    };
    $MyMoney{'MainCfg'}->window_close("KartaUcetnihoPohybu",$MyUI->TOPLEVEL);
    Gtk2->main_quit;
};

sub on_button_ok_clicked {
    $KartaUcetnihoPohybu->ReadFromUI($MyUI->FORM);
    $KartaUcetnihoPohybu->set('sloupec',$MyUI->get_sloupec);
    if(!$KartaUcetnihoPohybu->get('zkrat')) {
            my $Dialog=new Dialog(%MyMoney);
            $Dialog->show("text"=>"Zkratka nemůže být prázdná!","type"=>"error");
            return;        
    };
    if($MyUI->{'where'}) {
        if(!$KartaUcetnihoPohybu->update) {
            return;
        };
    } else {
        if(!$KartaUcetnihoPohybu->save(1)) {
            my $Dialog=new Dialog(%MyMoney);
            $Dialog->show("text"=>"Záznam nelze uložit!\nZřejmě ukládáte duplicitní klíč.","type"=>"error");
            return;
        };
    };
    if($Locks) {
        $Locks->remove_lock;
    };
    $MyMoney{'MainCfg'}->window_close("KartaUcetnihoPohybu",$MyUI->TOPLEVEL);
    $retcode=$KartaUcetnihoPohybu;
    $MyUI->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub set_sloupec {
    my($self,$sloupec_zkr)=@_;
    my $i=0;
    foreach $_ (@sloupce_penden) {
        my @sl=@{$_};
        if($sl[1] eq $sloupec_zkr) {
            $self->FORM->{'sloupec_option'}->set_history($i);
        };
        $i++;
    };
};

sub get_sloupec {
    my($self)=@_;
    my @sl=@{$sloupce_penden[$self->FORM->{'sloupec_option'}->get_history]};
    return($sl[1]);
};

sub on_typ_toggled {
    my $i=0;
    if($MyUI->FORM->{'typ_P'}->get_active) {
        foreach $_ (@sloupce_penden) {
            my @sl=@{$_};
            if($sl[1]=~/^P/) {
                $MyUI->FORM->{'sloupec_'.$sl[1]}->show;
                $i++;
            } else {
                $MyUI->FORM->{'sloupec_'.$sl[1]}->hide;
            };
        };
        $i--;
        if($MyUI->FORM->{'sloupec_option'}->get_history > $i) {
            $MyUI->FORM->{'sloupec_option'}->set_history(0);
        };
    } else {
        foreach $_ (@sloupce_penden) {
            my @sl=@{$_};
            if($sl[1]=~/^P/) {
                $MyUI->FORM->{'sloupec_'.$sl[1]}->hide;
                $i++;
            } else {
                $MyUI->FORM->{'sloupec_'.$sl[1]}->show;
            };
        };
        if($MyUI->FORM->{'sloupec_option'}->get_history < $i) {
            $MyUI->FORM->{'sloupec_option'}->set_history($i);
        };
    };
};

1;
