#!/usr/bin/perl -w

package Locks;

BEGIN {
    use src::MymoneyUI;
};


use strict;
use POSIX qw(strftime);

#use Encode;
use utf8;
#use open ':utf8', ':std';

use lib "./";
use lib::Table;
use lib::Dialog;
use lib::Databaze;

my %MyMoney;


sub new {
  my $class = shift;
  my $self = {};
  bless $self, $class;
  %MyMoney=@_;
  $self->{'lock'}=new Table('g_Locks',%MyMoney);
  $self->{'lock'}->set('user_id',$MyMoney{'Uzivatel'}->get('id'));
  $self->{'lock'}->set('user_name',$MyMoney{'Uzivatel'}->get('jmeno'));
  $self->{'lock'}->set('pid',$$);
  my ($hostname)=`/bin/uname -n`;
  chomp($hostname);
  $self->{'lock'}->set('hostname',$hostname);
  return $self;
};

sub odstranit {
    my ($self, $where, %params) = @_;
    %MyMoney=%params;
    my $Databaze=new Databaze(%MyMoney);
    if(!$Databaze->Remove('g_Locks',$where)) {
        return(0);
    };
    return(1);
};

sub create_lock {
    my($self,$tablename,$where,$ignore_err)=@_;
    $self->{'lock'}->set('tablename',$tablename);
    if($tablename=~/^g_/) {
        $self->{'lock'}->set('agenda_id',0);
        $self->{'lock'}->set('rok_id',0);
    };
    if($tablename=~/^a_/) {
        $self->{'lock'}->set('agenda_id',$MyMoney{'AgendaData'}->get('id'));
        $self->{'lock'}->set('rok_id',0);
        my $tbl_prefix="a".$MyMoney{'AgendaData'}->get('id')."_";
        $tablename=~s/^a_/$tbl_prefix/;
    };
    if($tablename=~/^r_/) {
        $self->{'lock'}->set('agenda_id',$MyMoney{'AgendaData'}->get('id'));
        $self->{'lock'}->set('rok_id',$MyMoney{'RokData'}->get('id'));
        my $tbl_prefix="r".$MyMoney{'RokData'}->get('id')."_";
        $tablename=~s/^r_/$tbl_prefix/;
    };
    $where=~s/'/\\'/g;
    $self->{'lock'}->set('tablekey',$tablename.":".$where);
    $self->{'lock'}->set('time',strftime("%s",localtime));
    #if(!$self->{'lock'}->save(1)) {
    #    if(!$ignore_err) {
    #        my $Dialog=new Dialog(%MyMoney);
    #        $Dialog->show("text"=>"Záznam je uzamčen jiným uživatelem.\nProvedené změny nebude možné uložit.","type"=>"info");
    #    };
    #    return(0);
    #};
    #return(1);
    my $Databaze=new Databaze(%MyMoney);
    if(!$Databaze->connect) {
        print("Error: Locks->create_lock() - nelze se pripojit k DB!\n");
        exit;
    };
    $Databaze->begin_work;
    $Databaze->lock_tables('g_Locks');
    $Databaze->Read('g_Locks',"agenda_id='".$self->{'lock'}->get('agenda_id')."' AND rok_id='".$self->{'lock'}->get('rok_id')."' AND tablekey='".$self->{'lock'}->get('tablekey')."'","id");
    if($Databaze->numrows) {
        $Databaze->rollback;
        $Databaze->unlock_tables;
        if(!$ignore_err) {
            my $Dialog=new Dialog(%MyMoney);
            $Dialog->show("text"=>"Záznam je uzamčen jiným uživatelem.\nProvedené změny nebude možné uložit.","type"=>"info");
        };
        return(0);        
    };
    $self->{'lock'}->set_db($Databaze);
    if(!$self->{'lock'}->save(1)) {
        $Databaze->rollback;
        $Databaze->unlock_tables;
        print("Error: Locks->create_lock() - nelze ulozit zamek zaznamu!\n");
        exit;
    };
    $Databaze->commit;
    $Databaze->unlock_tables;    
    return(1);
};

sub remove_lock {
    my $self=shift;
    my $Databaze=new Databaze(%MyMoney);
    $Databaze->Remove('g_Locks',"id='".$self->{'lock'}->get('id')."'");
};

1;
