#!/usr/bin/perl -w

package MainCfg;

BEGIN {
    use src::MymoneyUI;
};


use strict;
use Mysql;

#use Encode;
use utf8;
#use open ':utf8', ':std';

use Gtk2;
init Gtk2;

use lib "./";
use lib::Dialog;

my $MyUI;
my %Cfg=(
        "dbtype"=>"mysql",
        "dbhost"=>"localhost",
        "dbuser"=>"MyMoney",
        "dbpasswd"=>"MyMoney",
        "dbname"=>"MyMoney",
        "user"=>"",
        "agenda"=>"",
        "rok"=>""
        );

my %dbtype=(
            "mysql" => 0,
            "Pg"    =>  1
           );

my $retcode;

my %blokovana_cisla=();

sub run {
    my ($class, %params) = @_;

    my $window=$class;
    $MyUI=$window;
    $window->TOPLEVEL->set_title('Konfigurace databáze');

    $window->FORM->{'db_optionmenu'}->set_history($dbtype{$Cfg{'dbtype'}});

    $window->FORM->{'entry_dbhost'}->set_text($Cfg{'dbhost'});
    $window->FORM->{'entry_dbname'}->set_text($Cfg{'dbname'});
    $window->FORM->{'entry_dbuser'}->set_text($Cfg{'dbuser'});
    $window->FORM->{'entry_dbpasswd'}->set_text($Cfg{'dbpasswd'});

    $MyUI->window_open("MainCfg",$MyUI->TOPLEVEL);
    $window->TOPLEVEL->show;
    
    Gtk2->main;
    return($retcode);
};

sub toplevel_hide    { shift->get_toplevel->hide    }
sub toplevel_close   { shift->get_toplevel->close   }
sub toplevel_destroy { shift->get_toplevel->destroy }

sub on_button_ok_clicked {
    my $window=$MyUI;
    my %dbreverz;
    foreach $_ (keys(%dbtype)) {
        $dbreverz{$dbtype{$_}}=$_;
    };
    my $dbdriver=$dbreverz{$window->FORM->{'db_optionmenu'}->get_history};
    if(!$window->FORM->{'entry_dbhost'}->get_text) {
        my $Dialog=new Dialog;
        $Dialog->show("type"=>"warning","text"=>"Musi byt uveden nazev, nebo IP adresa hostitele!");
        return;
    };
    my $dbhost=$window->FORM->{'entry_dbhost'}->get_text;
    if(!$window->FORM->{'entry_dbname'}->get_text) {
        my $Dialog=new Dialog;
        $Dialog->show("type"=>"warning","text"=>"Musi byt uvedeno jmeno databaze!");
        return;
    };
    my $dbname=$window->FORM->{'entry_dbname'}->get_text;
    #if(!$window->FORM->{'entry_dbuser'}->get_text) {
    #    my $Dialog=new Dialog;
    #    $Dialog->show("type"=>"warning","text"=>"Musi byt uvedeno jmeno uzivatele pro pristup do databaze!");
    #    return;
    #};
    my $dbuser=$window->FORM->{'entry_dbuser'}->get_text;
    #if(!$window->FORM->{'entry_dbpasswd'}->get_text) {
    #    my $Dialog=new Dialog;
    #    $Dialog->show("type"=>"warning","text"=>"Musi byt uvedeno heslo pro pristup do databaze!");
    #    return;
    #};
    my $dbpasswd=$window->FORM->{'entry_dbpasswd'}->get_text;
    
    $Cfg{'dbtype'}=$dbdriver;
    $Cfg{'dbhost'}=$dbhost;
    $Cfg{'dbname'}=$dbname;
    $Cfg{'dbuser'}=$dbuser;
    $Cfg{'dbpasswd'}=$dbpasswd;
    $MyUI->write_config;
    $MyUI->window_close("MainCfg",$MyUI->TOPLEVEL);
    $window->TOPLEVEL->hide;
    $retcode=1;
    Gtk2->main_quit;
};

sub on_MainCfg_unrealize {
    $retcode=0;
    $MyUI->window_close("MainCfg",$MyUI->TOPLEVEL);
    Gtk2->main_quit;
};

sub on_button_close_clicked {
    $retcode=0;
    $MyUI->window_close("MainCfg",$MyUI->TOPLEVEL);
    $MyUI->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub read_config {
    my ($class, %params) = @_;

    $_=`cd ~;pwd`;
    chomp;
    my $rcfile=$_."/.mymoneyrc";
    if(! -e $rcfile) {
        return(0);
    } else {
      open(RCFILE,$rcfile) or die("Error in read_config: $!\n");
      while(<RCFILE>) {
        chomp;
        my($key,$val)=split('=',$_);
        $Cfg{$key}=$val;
      };
      close(RCFILE);
    };
    return(1);
};
    

sub write_config {
    $_=`cd ~;pwd`;
    chomp;
    my $rcfile=$_."/.mymoneyrc";
    open(RCFILE,">".$rcfile) or die("Error in write_config: $!\n");
    foreach $_ (keys(%Cfg)) {
        print(RCFILE $_."=".$Cfg{$_}."\n");
    };
    close(RCFILE);
};

sub get {
    my($class,$key)=@_;
    if(defined($Cfg{$key})) {
        return($Cfg{$key});
    };
    return(0);
};

sub set {
    my($class,$key,$value)=@_;
    $Cfg{$key}=$value;
};

sub window_close {
    my($self,$wname,$window)=@_;
    my ($x,$y)=$window->get_position;
    my ($width,$height)=$window->get_size;
    $self->set("WINDOW-".$wname,"$x,$y,$width,$height");
};

sub window_open {
    my($self,$wname,$window)=@_;
    if((my $geometry=$self->get("WINDOW-".$wname))) {
        my ($x,$y,$width,$height)=split(',',$geometry);
        $window->move($x,$y);
        $window->resize($width,$height);
    };
};

1;
